const StringUtils = require('./StringUtils');

class RequestPreprocessor {
  constructor() {}

  static process(request) {
    return new Promise(resolve => {
      try {
        const processed = Object.assign({}, request);
        processed.text = RequestPreprocessor.processText(processed.text);
        resolve(processed);
      } catch (e) {
        resolve(request);
      }
    });
  }

  static processText(text) {
    return StringUtils.unaccent(text.toLowerCase());
  }
}

module.exports = RequestPreprocessor;
